function result=generate_rayleigh(no_samples,f_dopp,f_s)
%Simulation Models With Correct Statistical
%Properties for Rayleigh Fading Channels
%Yahong Rosa Zheng and Chengshan Xiao, Senior Member, IEEE

czasy=[0:1/f_s:(no_samples-1)/f_s];% w sekundach
M=40;% ilosc kierunkow z ktorych dochodza promienie
losowa_faza=rand(1,1)*2*pi-pi;
result=sqrt(2)*cos(pi/4)*cos(2*pi*f_dopp*czasy+losowa_faza)+1j*sqrt(2)*sin(pi/4)*cos(2*pi*f_dopp*czasy+losowa_faza);%dla n=0
for i=1:M
    losowa_faza=rand(1,1)*2*pi-pi;
    result=result+2*cos(pi*i/M)*cos(2*pi*f_dopp*cos(2*pi*i/(4*M+2))*czasy+losowa_faza)+1j*2*sin(pi*i/M)*cos(2*pi*f_dopp*cos(2*pi*i/(4*M+2))*czasy+losowa_faza);
%     plot(abs(wynik))
end
result=result*2/sqrt(2*(4*M+2));%mianownik wymnozony przez dwa dla normalizacji w stosunku do artykulu